
#property copyright "Copyright  2005, Jason Robinson (jnrtrading)"
#property link      "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Magenta

#property indicator_width1 3
#property indicator_width2 3

double CrossUp[];
double CrossDown[];
extern int FasterEMA = 5;
extern int SlowerEMA = 40;
extern int level=6;

extern bool Alerts = false;
int upalert=false,downalert=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 241);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 242);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double fasterEMAnow, slowerEMAnow, fasterEMAprevious, slowerEMAprevious, fasterEMAafter, slowerEMAafter;
    double fasterEMAnow1, slowerEMAnow1, fasterEMAprevious1, slowerEMAprevious1, fasterEMAafter1, slowerEMAafter1;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      fasterEMAnow = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_MEDIAN, i)+level*Point;
      fasterEMAprevious = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_MEDIAN, i+1)+level*Point;
      fasterEMAafter = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_MEDIAN, i-1)+level*Point;

      slowerEMAnow = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_MEDIAN, i)-level*Point;
      slowerEMAprevious = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_MEDIAN, i+1)-level*Point;
      slowerEMAafter = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_MEDIAN, i-1)-level*Point;
      
      fasterEMAnow1 = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_MEDIAN, i)-level*Point;
      fasterEMAprevious1 = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_MEDIAN, i+1)-level*Point;
      fasterEMAafter1 = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_MEDIAN, i-1)-level*Point;

      slowerEMAnow1 = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_MEDIAN, i)+level*Point;
      slowerEMAprevious1 = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_MEDIAN, i+1)+level*Point;
      slowerEMAafter1 = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_MEDIAN, i-1)+level*Point;
      
      
      if ((fasterEMAnow1 > slowerEMAnow1) && (fasterEMAprevious1 < slowerEMAprevious1) && (fasterEMAafter1 > slowerEMAafter1)) {
         CrossUp[i] = Low[i] - Range*0.5;
         if(i<=2 && Alerts && !upalert)
           {
            Alert (Symbol()," ",Period(),"M  EMACross UP ");
            SendMail("Channel Cross Up on "+Symbol()+Period(),"");
            upalert=true;
            downalert=false;
            }
      }
      else if ((fasterEMAnow < slowerEMAnow) && (fasterEMAprevious > slowerEMAprevious) && (fasterEMAafter < slowerEMAafter)) {
         CrossDown[i] = High[i] + Range*0.5;
         if(i<=2 && Alerts && !downalert)
           {
            Alert (Symbol()," ",Period(),"M  EMACross DOWN ");
            SendMail("Channel Cross Down on "+Symbol()+Period(),"");
            downalert=true;
            upalert=false;
            }
      }
   }
   return(0);
}

